import 'package:flutter/material.dart';

class DefaultButton extends StatefulWidget {
  final String text;
  final Function onTap;

  DefaultButton({@required this.text, @required this.onTap});

  @override
  _DefaultButtonState createState() => _DefaultButtonState();
}

class _DefaultButtonState extends State<DefaultButton> {
  double height = 50;
  Color color = Colors.grey.withOpacity(0.4);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        _animateButton();

        if (widget.onTap != null) {
          widget.onTap();
        }
      },
      child: AnimatedContainer(
        duration: const Duration(milliseconds: 200),
        height: height,
        margin: EdgeInsets.symmetric(vertical: 20, horizontal: 60),
        alignment: Alignment.center,
        width: MediaQuery.of(context).size.width,
        decoration: BoxDecoration(
            color: color, borderRadius: BorderRadius.circular(25)),
        child: Text(
          widget.text ?? "",
          style: TextStyle(
              fontSize: 20, fontWeight: FontWeight.bold, color: Colors.black),
        ),
      ),
    );
  }

  Future<void> _animateButton() async {
    if (!mounted) return;

    setState(() {
      height = 52;
      color = Colors.grey.withOpacity(0.2);
    });

    await Future.delayed(const Duration(milliseconds: 300), () {
      if (!mounted) return;

      setState(() {
        height = 50;
        color = Colors.grey.withOpacity(0.4);
      });
    });
  }
}
