import 'package:flutter/cupertino.dart';

import '../../floative_flutter.dart';
import '../controller/floative_controller.dart';

mixin FloativeViewMixin<Controller extends FloativeController> {
  Controller get controller {
    var controllerInstance = Floative.I.factory.get()<Controller>();
    if (controllerInstance == null) {
      throw FloativeException(
          "The controller is not registered in Floative's GetIt instance");
    } else {
      return controllerInstance;
    }
  }

  void dismissKeyboard() {
    Ship.I.navigationKey.currentState.focusScopeNode.requestFocus(FocusNode());
  }

  String translate(String key) {
    return key;
  }
}
