part of 'floative_factory.dart';

class _FloativeFactoryImpl implements FloativeFactory {
  static final _registeredInstances = <Type, Object>{};

  @override
  T get<T>() {
    if (_FactoryHelper.isRegistered<T>(_registeredInstances)) {
      var result = _registeredInstances[T];
      return result;
    } else {
      return null;
    }
  }

  @override
  void register<T>(Object instance, {bool overrideInstance = false}) {
    if (_FactoryHelper.isNotRegistered<T>(_registeredInstances)) {
      _registeredInstances.putIfAbsent(T, () => instance);
    } else {
      if (overrideInstance) {
        _registeredInstances[T] = instance;
      }
    }
  }

  @override
  void registerLazySingleton<T>(Object instance) {}

  @override
  void dispose<T>() {
    if (_FactoryHelper.isRegistered<T>(_registeredInstances)) {
      _registeredInstances.remove(T);
    }
  }
}
