import 'package:flutter/material.dart';

import '../core/flavor/flavor.dart';
import '../core/floative_base/floative.dart';
import '../ship/ship.dart';

class FloativeMaterialApp extends StatelessWidget {
  final Widget home;
  final bool showDebugBanner;
  final Flavor flavor;
  final bool showFloativeLogs;

  FloativeMaterialApp(
      {@required this.home,
      this.showDebugBanner = false,
      this.flavor,
      this.showFloativeLogs}) {
    Floative.I.currentFlavor = flavor;
    Floative.I.enableFloativeLogs = showFloativeLogs;
    Ship.I.init();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      debugShowCheckedModeBanner: showDebugBanner,
      navigatorKey: Ship.I.navigationKey,
      navigatorObservers: [Ship.I.navigationObserver],
      home: home,
    );
  }
}
